﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Optimization;

/// <summary>
/// CSS and JS Bundles for all pages : BundleConfig
/// </summary>
/// <Author>  Prashik  </Author>

public class BundleConfig
{
    private static readonly BundleMimeType CssContentMimeType = new BundleMimeType("text/css");
    private static readonly BundleMimeType JsContentMimeType = new BundleMimeType("text/javascript");
    public static void RegisterBundles(BundleCollection bundles)
    {
        #region SmartViews + Listviews + InMemoryDB => iview.aspx
        var smartviewsCSS = new Bundle("~/Css/smartviews");
        smartviewsCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/FixedColumns/css/les.min.css",
            // "~/ThirdParty/DataTables-1.10.13/extensions/ColReorder/css/colReorder.dataTables.min.css",
            // "~/ThirdParty/DataTables-1.10.13/extensions/Scroller/css/scroller.dataTables.css",
            "~/ThirdParty/bgrins-spectrum/spectrum.css",
            "~/Thirdparty/newMaterialUI/plugins/node-waves/waves.css",
            "~/Css/globalStyles.css",
            "~/Css/iviewNewUi.css",
            "~/Css/animate.min.css",
            "~/Css/jquery-ui-timepicker-addon.min.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css",
            "~/Js/jquery.timeentry.package/jquery.timeentry.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css",
            "~/Css/themes.css"
        );
        smartviewsCSS.EnableFileExtensionReplacements = true;
        smartviewsCSS.Transforms.Add(CssContentMimeType);
        smartviewsCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        smartviewsCSS.Orderer = new BundleSorter();
        bundles.Add(smartviewsCSS);

        var smartviewsJS = new Bundle("~/Js/smartviews")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/Thirdparty/newMaterialUI/plugins/node-waves/waves.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.js",
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/dataTables.buttons.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.flash.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.html5.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.print.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/jszip.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/pdfmake.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/vfs_fonts.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/FixedColumns/js/dataTables.fixedColumns.js",
            //  "~/ThirdParty/DataTables-1.10.13/extensions/ColReorder/js/dataTables.colReorder.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/ColReorderWithResize/ColReorderWithResize.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Scroller/js/dataTables.scroller.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/handlebars.min.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
             "~/ThirdParty/Highcharts/highcharts.js",
             "~/ThirdParty/Highcharts/highcharts-3d.js",
             "~/ThirdParty/Highcharts/highcharts-more.js",
             "~/ThirdParty/Highcharts/highcharts-exporting.js",
             "~/Js/common.js",//min
             "~/Js/iview.js",//min
             "~/Js/jsclient.js",//min
             "~/Js/process.js",//min
             "~/Js/helper.js",//min
             "~/Js/util.min.js",
             "~/Js/JDate.min.js",
             "~/Js/jquery-ui-timepicker-addon.min.js",
             "~/Js/jquery.timeentry.package/jquery.timeentry.min.js",
             "~/ThirdParty/bootstrap-tokenfield/dist/bootstrap-tokenfield.min.js",
             "~/Js/jquery.browser.min.js",
             "~/Js/printjs.js",//min
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/moment.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/jquery.visible.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/datetime-moment.js",
             "~/Js/iviewjs.js",//min
             //"~/Js/iviewColumnBuilder.js",
             "~/Js/smartViews.js",//min
             "~/ThirdParty/bgrins-spectrum/spectrum.js",
             "~/Js/dwbTstructFieldsUI.js"
            );
        smartviewsJS.EnableFileExtensionReplacements = true;
        smartviewsJS.Transforms.Add(JsContentMimeType);
        smartviewsJS.Orderer = new BundleSorter();
        bundles.Add(smartviewsJS);
        #endregion

        #region Form => tstruct.aspx
        var formCSS = new Bundle("~/Css/form");
        formCSS.Include(
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/ThirdParty/gridstack.js-0.3.0/dist/gridstack.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.min.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/codemirror/codemirror.css",
            "~/Css/jquery-ui-timepicker-addon.min.css",
            "~/Js/jquery.timeentry.package/jquery.timeentry.css",
            "~/Css/globalStyles.css",
            "~/Css/wizardComp.css",
            "~/css/ExportNew.css",
            "~/Css/import.css",
            "~/Css/responsibilties.css",
            "~/Css/propSheet.css",
            "~/Css/msgBoxLight.css",
            "~/Css/tstructNewUi.css",
            "~/Css/animate.min.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/themes.css",
            "~/Css/axDeveloperCustom.css"
        );
        formCSS.EnableFileExtensionReplacements = true;
        formCSS.Transforms.Add(CssContentMimeType);
        formCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        formCSS.Orderer = new BundleSorter();
        bundles.Add(formCSS);
        //BundleTable.EnableOptimizations = true;



        var formBasic = new Bundle("~/Js/formBasic")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.min.js",
             "~/Js/jquery.browser.min.js",
             "~/Js/printjs.min.js",
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/Js/noConflict.min.js",
             "~/Js/propSheet.js",
             "~/Js/jquery.timeentry.package/jquery.timeentry.min.js",
             "~/Js/alerts.js",//min
             "~/Js/jQueryUi/jquery.tablesorter.min.js",
             "~/ThirdParty/bootstrap-tokenfield/dist/bootstrap-tokenfield.min.js",
             "~/Js/common.js",//min
             "~/Js/ckeditor/ckeditor.js",
             "~/Js/ckRtf.js",
             //"~/Js/process.min.js",
             "~/Js/JDate.min.js",
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/thirdparty/jquery-ui/jquery-ui-autoCom/jquery-ui-autoCom.min.js",
             "~/Js/jquery-ui-timepicker-addon.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/ThirdParty/gridstack.js-0.3.0/dist/gridstack.js",
             "~/ThirdParty/gridstack.js-0.3.0/dist/gridstack.jQueryUI.js",
             "~/Js/jquery.msgBox.min.js",
             "~/Js/jQueryUi/jquery.scrollabletab.min.js",
             "~/Js/tstructvars.js",//min
             "~/Js/md5.min.js",
             "~/Js/adjustwindow.js",
             "~/Js/wizardComp.js",//min
             //"~/Js/tstruct.min.js",
             //"~/Js/helper.min.js",
             //"~/Js/jsclient.min.js",
             "~/Js/util.min.js",
             //"~/Js/main-tstruct.min.js",
             "~/Js/tstruct-pdf.min.js",
             //"~/Js/newGridJS.min.js",
             "~/newPopups/Remodal/remodal.min.js",
             "~/newPopups/axpertPopup.js",//min
             "~/Js/handlebars.min.js",
             //"~/Js/autoComplete.min.js",
             "~/Js/thirdparty/velocity.min.js",
             "~/Js/thirdparty/velocity.ui.min.js",
             "~/Js/dimmingdiv.min.js",
             "~/Js/expressions_config.min.js",
             "~/Js/createTheEditor.js",//min
             "~/Js/codemirror/codemirror.js",
             "~/Js/multiselect.min.js",
             "~/Js/codemirror/mode/sql.js",
             "~/Js/codemirror/addon/hint/sql-hint.js",
             "~/Js/sqlBuilder.js",//min
             "~/Js/htmlPages.js",
             "~/Js/codemirror/mode/javascript.js",
             "~/Js/codemirror/addon/hint/javascript-hint.js",
             "~/Js/AxDeveloperCustom.js"
            );
        formBasic.EnableFileExtensionReplacements = true;
        formBasic.Transforms.Add(JsContentMimeType);
        formBasic.Orderer = new BundleSorter();
        bundles.Add(formBasic);

        var formInit = new Bundle("~/Js/formInit")
            .Include(
             "~/Js/process.js",//min
             "~/Js/tstruct.js",//min
             "~/Js/helper.js",//min
             "~/Js/jsclient.js",//min
             "~/Js/main-tstruct.js",//min
             "~/Js/newGridJS.js",//min
             "~/Js/autoComplete.js",//min
             "~/Js/multigroupselect.js"//min
            );
        formInit.EnableFileExtensionReplacements = true;
        formInit.Transforms.Add(JsContentMimeType);
        formInit.Orderer = new BundleSorter();
        bundles.Add(formInit);
        #endregion


        #region ltrBundleCss + rtlBundleCss + bundleJs => iview.aspx
        var ltrBundleCss = new Bundle("~/UI/axpertUI/ltrBundleCss");
        ltrBundleCss.Include(
            "~/UI/axpertUI/style.bundle.css",
            "~/UI/axpertUI/plugins.bundle.css"
        );
        ltrBundleCss.EnableFileExtensionReplacements = true;
        ltrBundleCss.Transforms.Add(CssContentMimeType);
        ltrBundleCss.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        ltrBundleCss.Orderer = new BundleSorter();
        bundles.Add(ltrBundleCss);

        var rtlBundleCss = new Bundle("~/UI/axpertUI/rtlBundleCss");
        rtlBundleCss.Include(
            "~/UI/axpertUI/style.bundle.rtl.css",
            "~/UI/axpertUI/plugins.bundle.rtl.css"
        );
        rtlBundleCss.EnableFileExtensionReplacements = true;
        rtlBundleCss.Transforms.Add(CssContentMimeType);
        rtlBundleCss.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        rtlBundleCss.Orderer = new BundleSorter();
        bundles.Add(rtlBundleCss);

        var bundleJs = new Bundle("~/UI/axpertUI/bundleJs")
            .Include(
             "~/UI/axpertUI/plugins.bundle.js",
             "~/UI/axpertUI/scripts.bundle.js"
        );
        bundleJs.EnableFileExtensionReplacements = true;
        bundleJs.Transforms.Add(JsContentMimeType);
        bundleJs.Orderer = new BundleSorter();
        bundles.Add(bundleJs);
        #endregion
        #region Form => tstructnew.aspx
        var formNewCSS = new Bundle("~/Css/formnew");
        formNewCSS.Include(
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/ThirdParty/gridstackNew.js-0.3.0/dist/jquery-ui/jquery-ui.css",
            "~/ThirdParty/gridstackNew.js-0.3.0/dist/jquery-ui/jquery-ui.structure.css",
            "~/ThirdParty/gridstackNew.js-0.3.0/dist/gridstack.css",
            "~/UI/axpertUI/datatables.bundle.css"
        );
        formNewCSS.EnableFileExtensionReplacements = true;
        formNewCSS.Transforms.Add(CssContentMimeType);
        formNewCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        formNewCSS.Orderer = new BundleSorter();
        bundles.Add(formNewCSS);

        var formNewBasic = new Bundle("~/Js/formBasicNew")
            .Include(
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/UI/axpertUI/datatables.bundle.js",
             "~/Js/noConflict.min.js",
             "~/Js/propSheet.js",
             "~/Js/alertsNew.js",
             "~/Js/common.js",
             "~/Js/JDate.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/ThirdParty/gridstackNew.js-0.3.0/dist/jquery-ui/jquery-ui.js",
             "~/ThirdParty/gridstackNew.js-0.3.0/dist/gridstack.js",
             "~/ThirdParty/gridstackNew.js-0.3.0/dist/gridstack.jQueryUI.js",
             "~/Js/tstructvarsNew.js",
             "~/Js/md5.min.js",
             "~/Js/util.min.js",
             "~/Js/expressions_config.min.js",
             "~/Js/multiselect.min.js",
             "~/Js/sqlBuilder.js",
             "~/Js/AxDeveloperCustomNew.js"
            );
        formNewBasic.EnableFileExtensionReplacements = true;
        formNewBasic.Transforms.Add(JsContentMimeType);
        formNewBasic.Orderer = new BundleSorter();
        bundles.Add(formNewBasic);

        var formNewInit = new Bundle("~/Js/formInitNew")
            .Include(
             "~/Js/processNew.js",//min
             "~/Js/tstructNew.js",//min
             "~/Js/helperNew.js",//min
             "~/Js/jsclient.js",//min
             "~/Js/main-tstructNew.js",//min
             "~/Js/newGridJS.js",//min
             "~/Js/select2.js",//min

             "~/Js/multigroupselect.js"//min
            );
        formNewInit.EnableFileExtensionReplacements = true;
        formNewInit.Transforms.Add(JsContentMimeType);
        formNewInit.Orderer = new BundleSorter();
        bundles.Add(formNewInit);
        #endregion

        #region DbScript => AxDbscript.aspx
        var DbScriptCSS = new Bundle("~/Css/DbScript");
        DbScriptCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/Css/globalStyles.css",
            "~/Css/codemirror.css",
            "~/ThirdParty/codemirror/theme/elegant.css",
            "~/ThirdParty/codemirror/addon/hint/show-hint.css",
            "~/ThirdParty/fancytree-master/src/skin-material/ui.fancytree.css",
            "~/Css/dbScript.css"
        );
        DbScriptCSS.EnableFileExtensionReplacements = true;
        DbScriptCSS.Transforms.Add(CssContentMimeType);
        DbScriptCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        DbScriptCSS.Orderer = new BundleSorter();
        bundles.Add(DbScriptCSS);

        var DbScriptJS = new Bundle("~/Js/DbScriptJS")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.min.js",
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             //"~/Js/handlebars.min.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
             "~/Js/thirdparty/jquery-resizable.min.js",
             "~/Js/codemirror/codemirror.js",
             "~/Js/codemirror/mode/sql.js",
             "~/Js/codemirror/addon/edit/matchbrackets.js",
             "~/ThirdParty/codemirror/addon/edit/closebrackets.js",
             "~/ThirdParty/codemirror/addon/hint/show-hint.js",
             "~/ThirdParty/codemirror/addon/hint/sql-hint.js",
             "~/ThirdParty/fancytree-master/src/jquery-ui-dependencies/jquery.fancytree.ui-deps.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.glyph.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.filter.js",
             "~/Js/xmlToJson.min.js",
             "~/Js/AxDBScript.js",
             "~/Js/common.js"
             );
        DbScriptJS.EnableFileExtensionReplacements = true;
        DbScriptJS.Transforms.Add(JsContentMimeType);
        DbScriptJS.Orderer = new BundleSorter();
        bundles.Add(DbScriptJS);
        #endregion

        #region WizardCM => Wizardsetting_new.aspx
        var WizardCMCSS = new Bundle("~/Css/WizardCM");
        WizardCMCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/Css/developerWorkBench.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/Css/globalStyles.css",
            "~/Css/codemirror.css",
            "~/ThirdParty/codemirror/theme/elegant.css",
            "~/ThirdParty/codemirror/addon/hint/show-hint.css",
            "~/ThirdParty/fancytree-master/src/skin-material/ui.fancytree.css",
            "~/Css/WizardCM.css"
        );
        WizardCMCSS.EnableFileExtensionReplacements = true;
        WizardCMCSS.Transforms.Add(CssContentMimeType);
        WizardCMCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        WizardCMCSS.Orderer = new BundleSorter();
        bundles.Add(WizardCMCSS);

        var WizardCMJS = new Bundle("~/Js/WizardCMJS")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.min.js",
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/Jquery-2.2.2.min.js",
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             //"~/Js/handlebars.min.js",
             "~/Js/common.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
             "~/Js/script.js",
             "~/Js/DND.js",
             "~/Js/thirdparty/jquery-resizable.min.js",
             "~/Js/codemirror/codemirror.js",
             "~/Js/codemirror/mode/sql.js",
             "~/Js/codemirror/addon/edit/matchbrackets.js",
             "~/ThirdParty/codemirror/addon/edit/closebrackets.js",
             "~/ThirdParty/codemirror/addon/hint/show-hint.js",
             "~/ThirdParty/codemirror/addon/hint/sql-hint.js",
             "~/ThirdParty/fancytree-master/src/jquery-ui-dependencies/jquery.fancytree.ui-deps.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.glyph.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.filter.js",
             "~/Js/xmlToJson.min.js",
             "~/Js/AxWizardCM.js",
             "~/Js/common.js"
             );
        WizardCMJS.EnableFileExtensionReplacements = true;
        WizardCMJS.Transforms.Add(JsContentMimeType);
        WizardCMJS.Orderer = new BundleSorter();
        bundles.Add(WizardCMJS);
        #endregion

        #region ArrangeMenu => ArrangeMenu.aspx
        var ArrangeMenuCSS = new Bundle("~/Css/ArrangeMenu");
        ArrangeMenuCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/Css/globalStyles.css",
            //"~/ThirdParty/materialize/css/materialize.min.css",
            "~/ThirdParty/fancytree-master/src/skin-material/ui.fancytree.css",
            "~/Css/arrangeMenu.css",
            "~/Css/iconPopup.css"
            );
        ArrangeMenuCSS.EnableFileExtensionReplacements = true;
        ArrangeMenuCSS.Transforms.Add(CssContentMimeType);
        ArrangeMenuCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        ArrangeMenuCSS.Orderer = new BundleSorter();
        bundles.Add(ArrangeMenuCSS);

        var ArrangeMenuJS = new Bundle("~/Js/ArrangeMenuJS")
           .Include(
            "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
            "~/Js/noConflict.min.js",
            "~/ThirdParty/lodash.min.js",
            "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
            "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
            "~/Js/alerts.js",//min
            "~/newPopups/Remodal/remodal.js",//min
            "~/newPopups/axpertPopup.js",//min
            "~/ThirdParty/fancytree-master/src/jquery.fancytree.js",
            "~/ThirdParty/fancytree-master/src/jquery-ui-dependencies/jquery.fancytree.ui-deps.js",
            "~/ThirdParty/fancytree-master/src/jquery.fancytree.dnd5.js",
            "~/ThirdParty/fancytree-master/src/jquery.fancytree.edit.js",
            "~/ThirdParty/fancytree-master/src/jquery.fancytree.glyph.js",
            "~/ThirdParty/fancytree-master/src/jquery.fancytree.filter.js",
            "~/Js/xmlToJson.min.js",
            "~/Js/ArrangeMenu.js",
            "~/Js/common.js",
            "~/Js/iconPopup.js"
             );
        ArrangeMenuJS.EnableFileExtensionReplacements = true;
        ArrangeMenuJS.Transforms.Add(JsContentMimeType);
        ArrangeMenuJS.Orderer = new BundleSorter();
        bundles.Add(ArrangeMenuJS);
        #endregion

        #region Report Builder => iviewBuilder.aspx
        var reportBuilderCSS = new Bundle("~/Css/reportBuilder");
        reportBuilderCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/FixedColumns/css/les.min.css",
            "~/ThirdParty/seballot-spectrum/spectrum.css",
            "~/Thirdparty/newMaterialUI/plugins/node-waves/waves.css",
            "~/Css/globalStyles.css",
            //"~/Css/iviewNewUi.css",
            "~/Css/iviewBuilder.css",//min
            "~/Css/animate.min.css",
            "~/Css/jquery-ui-timepicker-addon.min.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css",
            "~/Js/jquery.timeentry.package/jquery.timeentry.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css"
        );
        reportBuilderCSS.EnableFileExtensionReplacements = true;
        reportBuilderCSS.Transforms.Add(CssContentMimeType);
        reportBuilderCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        reportBuilderCSS.Orderer = new BundleSorter();
        bundles.Add(reportBuilderCSS);

        var reportBuilderJS = new Bundle("~/Js/reportBuilder")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/Thirdparty/newMaterialUI/plugins/node-waves/waves.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.min.js",
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/dataTables.buttons.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.flash.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.html5.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.print.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/jszip.min.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/pdfmake.js",
             //"~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/vfs_fonts.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/FixedColumns/js/dataTables.fixedColumns.js",
            "~/ThirdParty/DataTables-1.10.13/extensions/ColReorderWithResize/ColReorderWithResize.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/handlebars.min.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
             "~/ThirdParty/Highcharts/highcharts.js",
             "~/ThirdParty/Highcharts/highcharts-3d.js",
             "~/ThirdParty/Highcharts/highcharts-more.js",
             "~/ThirdParty/Highcharts/highcharts-exporting.js",
             "~/Js/common.js",//min
             //"~/Js/iview.js",//min
             //"~/Js/jsclient.js",//min
             //"~/Js/process.js",//min
             //"~/Js/helper.js",//min
             //"~/Js/util.min.js",
             "~/Js/JDate.min.js",
             "~/Js/jquery-ui-timepicker-addon.min.js",
             "~/Js/jquery.timeentry.package/jquery.timeentry.min.js",
             "~/ThirdParty/bootstrap-tokenfield/dist/bootstrap-tokenfield.min.js",
             "~/Js/jquery.browser.min.js",
             "~/Js/printjs.js",//min
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/moment.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/jquery.visible.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/datetime-moment.js",
             //"~/Js/iviewjs.js",//min
             //"~/Js/smartViews.js",//min
             "~/ThirdParty/seballot-spectrum/spectrum.js",
             "~/Js/expressions_config.js",
             "~/Js/createTheEditor.js",//min
             "~/Js/codemirror/codemirror.js",
             "~/Js/iviewBuilder.js"//min
            );
        reportBuilderJS.EnableFileExtensionReplacements = true;
        reportBuilderJS.Transforms.Add(JsContentMimeType);
        reportBuilderJS.Orderer = new BundleSorter();
        bundles.Add(reportBuilderJS);
        #endregion

        #region Axpert API => axpertAPI.aspx
        var axpertApiCSS = new Bundle("~/Css/axpertAPI");
        axpertApiCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/Css/globalStyles.css",
            "~/Css/axpertAPI.css"
            );
        axpertApiCSS.EnableFileExtensionReplacements = true;
        axpertApiCSS.Transforms.Add(CssContentMimeType);
        axpertApiCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        axpertApiCSS.Orderer = new BundleSorter();
        bundles.Add(axpertApiCSS);

        var axpertApiJS = new Bundle("~/Js/axpertAPI")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
             "~/Js/common.js",
            "~/Js/axpertAPI.js"
            );
        axpertApiJS.EnableFileExtensionReplacements = true;
        axpertApiJS.Transforms.Add(JsContentMimeType);
        axpertApiJS.Orderer = new BundleSorter();
        bundles.Add(axpertApiJS);
        #endregion

        #region Toolbar Manager => ToolbarManager.aspx
        var ToolbarManagerCSS = new Bundle("~/Css/ToolbarManager");
           ToolbarManagerCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/Css/globalStyles.css",
            "~/ThirdParty/fancytree-master/src/skin-material/ui.fancytree.css",
            "~/Css/toolbarManager.css",
            "~/Css/iconPopup.css"
            );
        ToolbarManagerCSS.EnableFileExtensionReplacements = true;
        ToolbarManagerCSS.Transforms.Add(CssContentMimeType);
        ToolbarManagerCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        ToolbarManagerCSS.Orderer = new BundleSorter();
        bundles.Add(ToolbarManagerCSS);

        var ToolbarManagerJS = new Bundle("~/Js/ToolbarManager");
            ToolbarManagerJS.Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/Js/common.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.js",
             "~/ThirdParty/fancytree-master/src/jquery-ui-dependencies/jquery.fancytree.ui-deps.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.dnd5.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.edit.js",
             "~/ThirdParty/fancytree-master/src/jquery.fancytree.glyph.js",
             "~/Js/expressions_config.js",
             "~/Js/createTheEditor.js",//min
             "~/Js/codemirror/codemirror.js",
             "~/Js/toolbarManager.js",
             "~/Js/iconPopup.js"
            );
        ToolbarManagerJS.EnableFileExtensionReplacements = true;
        ToolbarManagerJS.Transforms.Add(JsContentMimeType);
        ToolbarManagerJS.Orderer = new BundleSorter();
        bundles.Add(ToolbarManagerJS);
        #endregion

        #region Add Form => addForm.aspx
        var addFormCss = new Bundle("~/Css/addFormCss");
        addFormCss.Include(
            "~/Js/ckeditor/skins/moono-lisa/editor.css",
            "~/ThirdParty/gridstack.js-5.1.1/demo/demo.css"
        );
        addFormCss.EnableFileExtensionReplacements = true;
        addFormCss.Transforms.Add(CssContentMimeType);
        addFormCss.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        addFormCss.Orderer = new BundleSorter();
        bundles.Add(addFormCss);        

        var addFormJs = new Bundle("~/Js/addFormJs")
            .Include(
            "~/Js/noConflict.min.js",
            "~/Js/alertsNew.js",
            "~/Js/common.js",
            "~/Js/helperNew.js",//min
            "~/ThirdParty/gridstack.js-5.1.1/dist/es5/gridstack-jq.js",
            "~/ThirdParty/lodash.min.js",
            "~/Js/addForm.js"
        );
        addFormJs.EnableFileExtensionReplacements = true;
        addFormJs.Transforms.Add(JsContentMimeType);
        addFormJs.Orderer = new BundleSorter();
        bundles.Add(addFormJs);
        #endregion
    }
}

//public class CssRewriteUrlTransformWrapper : IItemTransform
//{
//    public string Process(string includedVirtualPath, string input)
//    {
//        return new CssRewriteUrlTransform().Process("~" + VirtualPathUtility.ToAbsolute(includedVirtualPath), input);
//    }
//}

public class CssRewriteUrlTransformWrapper : IBundleTransform
{
    private static Regex pattern = new Regex(@"url\s*\(\s*([""']?)([^:)]+)\1\s*\)", RegexOptions.IgnoreCase);

    public void Process(BundleContext context, BundleResponse response)
    {
        response.Content = string.Empty;
        foreach (BundleFile file in response.Files)
        {
            using (var reader = new StreamReader(file.VirtualFile.Open()))
            {
                var contents = reader.ReadToEnd();
                var matches = pattern.Matches(contents);
                if (matches.Count > 0)
                {
                    var directoryPath = VirtualPathUtility.GetDirectory(file.VirtualFile.VirtualPath);
                    foreach (Match match in matches)
                    {
                        var fileRelativePath = match.Groups[2].Value;
                        var fileVirtualPath = VirtualPathUtility.Combine(directoryPath, fileRelativePath);
                        var quote = match.Groups[1].Value;
                        var replace = String.Format("url({0}{1}{0})", quote, VirtualPathUtility.ToAbsolute(fileVirtualPath));
                        contents = contents.Replace(match.Groups[0].Value, replace);
                    }
                }
                response.Content = String.Format("{0}\r\n{1}", response.Content, contents);
            }
        }
    }
}

internal sealed class BundleMimeType : IBundleTransform
{
    private readonly string _mimeType;

    public BundleMimeType(string mimeType) { _mimeType = mimeType; }

    public void Process(BundleContext context, BundleResponse response)
    {
        if (context == null)
            throw new ArgumentNullException();
        if (response == null)
            throw new ArgumentNullException();
        /*
        if (context == null)
                        throw new ArgumentNullException(nameof(context));
        if (response == null)
                throw new ArgumentNullException(nameof(response));
         */

        response.ContentType = _mimeType;
    }
}
