window.onbeforeunload = function () {
    appGlobalVarsObject._CONSTANTS.callerWindow = null;
}

document.addEventListener('contextmenu', event => event.preventDefault());

var transid = "";

var sourceDetails = "";

var addedItemUpdated = false;

var addedItemRecordId = "0";

// var designJSON = "";

if (typeof callParentNew("AxConfigPage") != "undefined" && callParentNew("AxConfigPage") != "") {
    sourceDetails = callParentNew("AxConfigPage").split("~");
    (sourceDetails?.[0] == "addform") && (transid = sourceDetails?.[1]);
}
else {
    ShowAlertDialog("error", "An error occurred while opening the page");
    // return;
}

let grid = GridStack.init({
    column: 36,
    cellHeight: 115,
    float: true,
    acceptWidgets: true,
    minRow: 10, // don't collapse when empty
    dragIn: '.sidebar .grid-stack-item',  // class that can be dragged from outside
    dragInOptions: { revert: 'invalid', scroll: false, appendTo: 'body', helper: 'clone' }, // clone or can be your function
    removable: '#trash', // drag-out delete class
}).on('resizestart', function (event, el) {
    $(el).parent().addClass("ui-droppable-active");
}).on('resizestop', function (event, el) {
    $(el).parent().removeClass("ui-droppable-active");
}).on('added', function (event, items) {
    //open field propertysheet 
    items.forEach(function (item, index) {
        if (index == 0) {
            addedItemUpdated = false;

            let controlID = `ax_fld_id${Math.floor(Math.random() * 100000)}`;

            $(item.el).attr("data-control-id", controlID).data("data-control-id", controlID);

            if (sourceDetails?.[0] == "addform") {
                let addedItemCaption = item.el?.dataset?.placeholder;

                let myModal = new BSModal(controlID, addedItemCaption, `<iframe id="modal-addfield" src="tstructnew.aspx?act=open&transid=ad_af&stransid=${transid}&formcaption=${transid}&fcaption=${$(item.el).data("placeholder")}&fldtype=${addedItemCaption}" class="w-100 vh-100"></iframe>`, 
                (opening) => {
                    $(myModal.modal._element).attr("data-control-id", controlID).data("data-control-id", controlID);
                    appGlobalVarsObject._CONSTANTS.callerWindow = window;
                    appGlobalVarsObject._CONSTANTS.calledWindow = null;
                }, 
                (closed) => {
                    // debugger;&flddtype=Character&flddwidth=1000&flddecimal=0&fldctl=1
                    if (!addedItemUpdated) {
                        grid.removeWidget(item.el, true, true);
                    } else {
                        if (addedItemUpdated && addedItemRecordId != "0") {
                            $(item.el).attr("data-recid", addedItemRecordId).data("data-recid", addedItemRecordId);

                            $(item.el).attr("data-placeholder", addedItemCaption).data("data-placeholder", addedItemCaption);
                        }
                    }

                    addedItemUpdated = false;
                    addedItemRecordId = "0";
                    if(appGlobalVarsObject._CONSTANTS.callerWindow) {
                        appGlobalVarsObject._CONSTANTS.callerWindow = null;
                    }
                    appGlobalVarsObject._CONSTANTS.calledWindow = null;
                });

                myModal.scrollableDialog();

                myModal.cancelBtn.classList.add("d-none");

                myModal.okBtn.removeAttribute("data-bs-dismiss");
                myModal.okBtn.innerText = appGlobalVarsObject.lcm[399];
                myModal.okBtn.addEventListener("click", (e) => {
                    $(document.getElementById("modal-addfield"))[0].contentWindow.$(".toolbarRightMenu").find("a[title=usave]").trigger("click");
                });
            }

        }
    });
});

function editFieldProperty(curEditElement) {
    let addedItemControlId = curEditElement.data("controlId");
    let addedItemCaption = curEditElement.data("placeholder");
    addedItemRecordId = curEditElement.data("recid");

    let myModal = new BSModal(addedItemControlId, addedItemCaption, `<iframe id="modal-editfield" src="tstructnew.aspx?act=load&transid=ad_af&recordid=${addedItemRecordId}" class="w-100 vh-100"></iframe>`,
        (opening) => {
            $(myModal.modal._element).attr("data-control-id", addedItemControlId).data("data-control-id", addedItemControlId);
            appGlobalVarsObject._CONSTANTS.callerWindow = window;
            appGlobalVarsObject._CONSTANTS.calledWindow = null;
        },
        (closed) => {
            if (!addedItemUpdated && addedItemRecordId == "0") {
                grid.removeWidget(curEditElement?.[0], true, true);
            } else {
                if (addedItemUpdated && addedItemRecordId != "0") {
                    $(curEditElement).attr("data-recid", addedItemRecordId).data("data-recid", addedItemRecordId);
                    $(curEditElement).attr("data-placeholder", addedItemCaption).data("data-placeholder", addedItemCaption);
                }
            }

            addedItemUpdated = false;
            addedItemRecordId = "0";
            if(appGlobalVarsObject._CONSTANTS.callerWindow) {
                appGlobalVarsObject._CONSTANTS.callerWindow = null;
            }
            appGlobalVarsObject._CONSTANTS.calledWindow = null;
        });

    myModal.scrollableDialog();

    myModal.cancelBtn.removeAttribute("data-bs-dismiss");
    myModal.cancelBtn.innerText = appGlobalVarsObject.lcm[248];
    myModal.cancelBtn.addEventListener("click", (e) => {
        // $(e.target).parents(".modal").find("iframe")[0].contentWindow.$(".toolbarRightMenu").find("a[title=uremove]").trigger("click");
        // $(document.getElementById("modal-editfield"))[0].contentWindow.$(".toolbarRightMenu").find("a[title=uremove]").trigger("click");

        // $(callParentNew("btnadafuremove", "id")).trigger("click");
        $(document.getElementById("modal-editfield"))[0].contentWindow.$(".toolbarRightMenu").find("a[title=uremove]").trigger("click");
    });

    myModal.okBtn.removeAttribute("data-bs-dismiss");
    myModal.okBtn.innerText = appGlobalVarsObject.lcm[399];
    myModal.okBtn.addEventListener("click", (e) => {
        $(document.getElementById("modal-editfield"))[0].contentWindow.$(".toolbarRightMenu").find("a[title=usave]").trigger("click");
    });
}

function getDesignerJSON() {
    var dsnJSON = "";
    var typeee_as_grid = '';

    this.form_serialized_data = _.map($('body'), function (el) {
        this.dc_serialized_data = _.map($('.grid-stack'), function (el) {
            el = $(el);
            dc_id = $(el).attr("id");
            typeee_as_grid = el.parents(".grid-icons").length > 0 ? "T" : "F";
            this.serialized_data = _.map($('#' + dc_id + ' > .grid-stack-item'), function (el) {
                el = $(el);
  
                return {
                    fld_id: $(el).data("id"),
                    x: +el.attr("gs-x"),
                    y: +el.attr("gs-y"),
                    w: +el.attr("gs-w"),
                    h: +el.attr("gs-h"),
                    visibility: !el.hasClass("designHidden"),
                };
            }, this);

            var fieldsDesign = this.serialized_data.length ? GridStack.Utils.sort(this.serialized_data, 1, 36).map(fld => { return { fld_id: fld.fld_id, x: fld.x, y: fld.y, width: fld.w, height: fld.h, visibility: fld.visibility } }) : null;
            // var tableDesign = this.serialized_data_table.length ? this.serialized_data_table : null;
            dc_id = dc_id.indexOf("divDc") == 0 ? dc_id.substr(5) : dc_id.substr(dc_id.lastIndexOf("F") + 1);
            return {
                dc_id,
                isGrid: false,//typeee_as_grid,
                gridStretch: false,//$("#ckbGridStretch" + dc_id).is(":checked"), //To be changed with grid stretch
                fieldsDesign,
                tableDesign: [],
            };
        }, this);
        var form_data = (typeof dcLayoutType == "undefined" || dcLayoutType == "" || dcLayoutType == "default") ? (typeof isDcLayoutSelected != "undefined" && isDcLayoutSelected == true ? designObj[0].dcs : (this.dc_serialized_data)) : designObj[0].dcs;
        var newform_data = (typeof dcLayoutType != "undefined" && dcLayoutType != "" && dcLayoutType != "default") ? (this.dc_serialized_data) :/*designObj?.[0]?.newdcs*/[];
        return {
            transid,
            compressedMode: true,//$("#ckbCompressedMode").is(":checked"),
            newDesign: true,
            staticRunMode: true,//$("#ckbStaticRunMode").prop('checked'),
            wizarcdDC: false,//$("#ckbWizardDC").prop('checked'),
            selectedLayout: null,//$("#designLayoutSelector").val(),
            selectedFontSize: 14,//$("#designForntSizeSelector").val(),
            selectedControlHeight: 25,//$("#designControlHeightSelector").val(),
            tstUpdatedOn: typeof tstructUpdateOn != "undefined" ? tstructUpdateOn : "",
            dcLayout: "default",//typeof dcLayoutType != "undefined" && dcLayoutType != "" ? dcLayoutType : "default",
            formWidth: "100",//$("#designFormWidthSelector").val(),
            formAlignment: "default",//$("#designFormAlignmentSelector").val(),
            fieldCaptionWidth: "30",//$("#designFieldCaptionWidthSelector").val(),
            formLabel: typeof formLabelJSON != "undefined" && formLabelJSON != "" ? JSON.parse(formLabelJSON) : [],
            buttonFieldFont: typeof buttonFieldFontJSON != "undefined" && buttonFieldFontJSON != "" ? JSON.parse(buttonFieldFontJSON) : [],
            dcs: form_data,
            newdcs: newform_data
        };
    }, this);

    // if(dcLayoutType == "" || dcLayoutType == "default"){
    var newIndex = form_serialized_data[0].dcs.map(function (obj, index) {
        return obj.dc_id;
    });

    var oldUpdatedObject = [];
    try {
        if (designObj[0].dcs != null) {
            oldUpdatedObject = designObj[0].dcs.filter(function (obj, index) {
                if (newIndex.indexOf(obj.dc_id) == -1) {
                    return true;
                }
            });
        }
    } catch (ex) {

    }

    form_serialized_data[0].dcs = _.sortBy([...form_serialized_data[0].dcs, ...oldUpdatedObject], 'dc_id');

    dsnJSON = JSON.stringify(this.form_serialized_data, null, '');


    return dsnJSON;
}



function formSave(){
    SavePublishDesignerJSONWeb(false);
    
    appGlobalVarsObject._CONSTANTS.callerWindow = window;
    appGlobalVarsObject._CONSTANTS.window.$('#btn_readtstructdef').trigger('click');
}


function SavePublishDesignerJSONWeb(isSaveNormal = true) {
    var dsnJSON = getDesignerJSON();
    var SavedId = $("#SaveID").val();
    var PublishId = $("#PublishID").val();
    var Savetype = "SAVEPUBLISH";
    $(".grid-stack").removeClass('dirty')
    $.ajax({
        url: 'tstruct.aspx/SavePublishDesign',
        type: 'POST',
        cache: false,
        async: true,
        data: JSON.stringify({
            Transid: transid, DesignType: Savetype, Content: dsnJSON, SavedId: SavedId
        }),
        dataType: 'json',
        contentType: "application/json",
        success: function (data) {
            if (data.d != "") {
                SavedId = data.d.split('~')[0];
                PublishId = data.d.split('~')[1];
                $("#SaveID").attr("value", SavedId);
                if (isSaveNormal)
                    showAlertDialog("success", DesigntstructMessages.designSaved);
                $("#PublishID").val(PublishId);
                $("#IsPublish").val("Y");
            }
            else {
                showAlertDialog("error", "Error while save & publish design.");
            }
        }, error: function (error) {
            showAlertDialog("error", error);
        }
    });
}